'use strict';

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _react2 = require('react');

var _react3 = _interopRequireDefault(_react2);

var _reactTransformHmr3 = require('react-transform-hmr');

var _reactTransformHmr4 = _interopRequireDefault(_reactTransformHmr3);

var _class, _temp;

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _themeable = require('./themeable');

var _themeable2 = _interopRequireDefault(_themeable);

var _defaultTheme = require('./defaultTheme');

var _defaultTheme2 = _interopRequireDefault(_defaultTheme);

var _function = require('react-pure-render/function');

var _function2 = _interopRequireDefault(_function);

var _ActionList = require('./ActionList');

var _ActionList2 = _interopRequireDefault(_ActionList);

var _ActionPreview = require('./ActionPreview');

var _ActionPreview2 = _interopRequireDefault(_ActionPreview);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var _components = {
  DevtoolsInspector: {
    displayName: 'DevtoolsInspector'
  }
};

var _reactTransformHmr2 = (0, _reactTransformHmr4.default)({
  filename: 'src/DevtoolsInspector.js',
  components: _components,
  locals: [module],
  imports: [_react3.default]
});

function _wrapComponent(id) {
  return function (Component) {
    return _reactTransformHmr2(Component, id);
  };
}

var DevtoolsInspector = _wrapComponent('DevtoolsInspector')((_temp = _class = function (_Component) {
  (0, _inherits3.default)(DevtoolsInspector, _Component);

  function DevtoolsInspector(props) {
    (0, _classCallCheck3.default)(this, DevtoolsInspector);

    var _this = (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(DevtoolsInspector).call(this, props));

    _this.shouldComponentUpdate = _function2.default;

    _this.state = {
      isWideLayout: false,
      selectedActionId: null,
      inspectedPath: []
    };
    return _this;
  }

  (0, _createClass3.default)(DevtoolsInspector, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      var _this2 = this;

      this.updateSizeTimeout = window.setInterval(function () {
        return _this2.updateSizeMode();
      }, 150);
    }
  }, {
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      window.clearTimeout(this.updateSizeTimeout);
    }
  }, {
    key: 'updateSizeMode',
    value: function updateSizeMode() {
      this.setState({
        isWideLayout: this.refs.diffMonitor.offsetWidth > 500
      });
    }
  }, {
    key: 'render',
    value: function render() {
      var _this3 = this;

      var _props = this.props;
      var theme = _props.theme;
      var actionIds = _props.stagedActionIds;
      var actions = _props.actionsById;
      var computedStates = _props.computedStates;
      var _state = this.state;
      var isWideLayout = _state.isWideLayout;
      var selectedActionId = _state.selectedActionId;
      var inspectedPath = _state.inspectedPath;
      var searchValue = _state.searchValue;

      var createTheme = (0, _themeable2.default)((0, _extends3.default)({}, theme, _defaultTheme2.default));
      var lastActionId = actionIds[actionIds.length - 1];
      var currentActionId = selectedActionId === null ? lastActionId : selectedActionId;

      return _react3.default.createElement(
        'div',
        (0, _extends3.default)({ key: 'diffMonitor'
        }, createTheme('diffMonitor', 'diffMonitorLayout', isWideLayout && 'diffMonitorWideLayout'), {
          ref: 'diffMonitor' }),
        _react3.default.createElement(_ActionList2.default, (0, _extends3.default)({ theme: theme, defaultTheme: _defaultTheme2.default, actions: actions, actionIds: actionIds, isWideLayout: isWideLayout, searchValue: searchValue }, {
          selectedActionId: selectedActionId,
          onSearch: function onSearch(val) {
            return _this3.setState({ searchValue: val });
          },
          onSelect: function onSelect(actionId) {
            return _this3.setState({
              selectedActionId: actionId === selectedActionId ? null : actionId
            });
          } })),
        _react3.default.createElement(_ActionPreview2.default, (0, _extends3.default)({ theme: theme, defaultTheme: _defaultTheme2.default }, {
          fromState: currentActionId > 0 ? computedStates[currentActionId - 1] : null,
          toState: currentActionId ? computedStates[currentActionId] : null,
          onInspectPath: function onInspectPath(path) {
            return _this3.setState({ inspectedPath: path });
          },
          inspectedPath: inspectedPath }))
      );
    }
  }]);
  return DevtoolsInspector;
}(_react2.Component), _class.propTypes = {
  dispatch: _react2.PropTypes.func,
  computedStates: _react2.PropTypes.array,
  stagedActionIds: _react2.PropTypes.array,
  actionsById: _react2.PropTypes.object,
  currentStateIndex: _react2.PropTypes.number,
  monitorState: _react2.PropTypes.shape({
    initialScrollTop: _react2.PropTypes.number
  }),
  preserveScrollTop: _react2.PropTypes.bool,
  stagedActions: _react2.PropTypes.array,
  select: _react2.PropTypes.func.isRequired,
  theme: _react2.PropTypes.oneOfType([_react2.PropTypes.object, _react2.PropTypes.string])
}, _class.update = function (s) {
  return s;
}, _class.defaultProps = {
  theme: {},
  select: function select(state) {
    return state;
  }
}, _temp));

exports.default = DevtoolsInspector;